package com.nokia.finance.tasks.controller;

import com.nokia.finance.tasks.common.R;
import com.nokia.finance.tasks.pojo.dto.RunJobDto;
import com.nokia.finance.tasks.service.JobService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

@RestController
@RequestMapping("/jobs")
public class JobController {
    private final JobService jobService;

    public JobController(JobService jobService) {
        this.jobService = jobService;
    }

    @PostMapping("/runJob")
    public R<Object> runJob(@Valid @RequestBody RunJobDto dto) {
        return jobService.runJob(dto);
    }
}
