package com.nokia.finance.tasks.dao.common;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.nokia.finance.tasks.pojo.po.common.CarPhpRequestLogPo;
import com.nokia.finance.tasks.pojo.po.common.RequestLogPo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.util.List;

@Mapper
public interface RequestLogDao extends BaseMapper<RequestLogPo> {
    /**
     * 批量插入
     */
    @Update("""
<script>
insert into common.request_log
(
request_time,
login_id,
page_url,
api,
request_parameters,
headers,
app_id,
time_stamp,
token,
expire_time,
expire_time_stamp
)
values
<foreach collection="list" item="item" index="index" separator=",">
(
#{item.requestTime},
#{item.loginId},
#{item.pageUrl},
#{item.api},
#{item.requestParameters},
#{item.headers},
#{item.appId},
#{item.timeStamp},
#{item.token},
#{item.expireTime},
#{item.expireTimeStamp}
)
</foreach>
</script>
""")
    int insertBatch(List<RequestLogPo> list);

    @Select("""
select
    to_timestamp(create_time)::timestamp as request_time,
    query_string
from
    car_theme.wz_adminlog
where create_time >= #{startTime}
and create_time < #{endTime}
order by
    create_time
""")
    List<CarPhpRequestLogPo> listCarPhpRequestLog(@Param("startTime") Long startTime,
                                                  @Param("endTime") Long endTime);
}
