package com.nokia.finance.tasks.pojo.po.house_report;

import lombok.Data;

import java.math.BigDecimal;

@Data
public class HouseRentOutIncomeStatPo {
    /**
     * 年月
     */
    private Integer yearMonth;

    /**
     * 二级组织机构编码
     */
    private String areaNo;

    /**
     * 二级组织机构名称
     */
    private String areaName;

    /**
     * 三级组织机构编码
     */
    private String cityNo;

    /**
     * 三级组织机构名称
     */
    private String cityName;

    /**
     * 本年累计出租收入万元合计
     */
    private BigDecimal incomeAll;

    /**
     * 本年累计出租收入万元上市
     */
    private BigDecimal incomeSs;

    /**
     * 本年累计出租收入万元存续
     */
    private BigDecimal incomeCx;

    /**
     * 本年出租收入预算万元合计
     */
    private BigDecimal budgetAll;

    /**
     * 本年出租收入预算万元上市
     */
    private BigDecimal budgetSs;

    /**
     * 本年出租收入预算万元存续
     */
    private BigDecimal budgetCx;

    /**
     * 预算完成率
     */
    private BigDecimal budgetFinishRate;

    /**
     * 上年同期累计出租收入万元合计
     */
    private BigDecimal lastYearIncomeAll;

    /**
     * 较上年同期增减额万元
     */
    private BigDecimal yoy;

    /**
     * 同比百分比
     */
    private BigDecimal yoyPercent;

    /**
     * 收入贡献率
     */
    private BigDecimal contributionRate;

    /**
     * 预算完成排名
     */
    private Integer budgetFinishRank;

    /**
     * 增幅排名
     */
    private Integer increaseAmplitudeRank;
    /**
     * 序时进度
     */
    private BigDecimal sequentialProgress;
    /**
     * 序时进度差距
     */
    private BigDecimal sequentialProgressDiff;
}
