package com.nokia.finance.tasks.pojo.vo.car_report;

import com.nokia.finance.tasks.pojo.po.car_report.CarDxUnitPo;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.text.DecimalFormat;

@NoArgsConstructor
@Data
public class CarDxUnitVo {
    /**
     * 序号
     */
    private String num;
    /**
     * 一级单位
     */
    private String firstUnit;
    /**
     * 去年车数
     */
    private String totalLy;
    /**
     * 去年低效车数
     */
    private String diXiaoCountLy;
    /**
     * 去年低效占比
     */
    private String diXiaoPercentLy;
    /**
     * 今年车数
     */
    private String totalTy;
    /**
     * 今年低效车数
     */
    private String diXiaoCountTy;
    /**
     * 今年低效占比
     */
    private String diXiaoPercentTy;
    /**
     * 低效占比变化
     */
    private String diXiaoChange;

    public CarDxUnitVo(String num, String firstUnit) {
        this.num = num;
        this.firstUnit = firstUnit;
        this.totalLy = "";
        this.diXiaoCountLy = "";
        this.diXiaoPercentLy = "";
        this.totalTy = "";
        this.diXiaoCountTy = "";
        this.diXiaoPercentTy = "";
        this.diXiaoChange = "";
    }

    public CarDxUnitVo(Integer num, String firstUnit) {
        this.num = String.valueOf(num);
        this.firstUnit = firstUnit;
        this.totalLy = "0";
        this.diXiaoCountLy = "0";
        this.diXiaoPercentLy = "0.0%";
        this.totalTy = "0";
        this.diXiaoCountTy = "0";
        this.diXiaoPercentTy = "0.0%";
        this.diXiaoChange = "0.0%";
    }

    public void update(CarDxUnitPo carDxUnitPo) {
        DecimalFormat integerFormat = new DecimalFormat("#,###");
        DecimalFormat percentFormat = new DecimalFormat("0.0%");
        this.totalLy = integerFormat.format(carDxUnitPo.getTotalLy());
        this.diXiaoCountLy = integerFormat.format(carDxUnitPo.getDiXiaoCountLy());
        this.diXiaoPercentLy = percentFormat.format(carDxUnitPo.getDiXiaoPercentLy());
        this.totalTy = integerFormat.format(carDxUnitPo.getTotalTy());
        this.diXiaoCountTy = integerFormat.format(carDxUnitPo.getDiXiaoCountTy());
        this.diXiaoPercentTy = percentFormat.format(carDxUnitPo.getDiXiaoPercentTy());
        this.diXiaoChange = percentFormat.format(carDxUnitPo.getDiXiaoChange());
    }
}
