package com.nokia.finance.tasks.pojo.vo.car_report;

import com.nokia.finance.tasks.pojo.po.car_report.CarJygxUnitPo;
import lombok.Data;

import java.text.DecimalFormat;

@Data
public class CarJygxUnitVo {
    /**
     * 单位
     */
    private String firstUnit;
    /**
     * 轿车
     */
    private String jc;
    /**
     * 皮卡车
     */
    private String pkc;
    /**
     * 商务车
     */
    private String swc;
    /**
     * 特种车
     */
    private String tzc;
    /**
     * 越野车
     */
    private String yyc;
    /**
     * 中型面包车（8-20座的面包车）
     */
    private String zxmbc;
    /**
     * 总计
     */
    private String total;

    public CarJygxUnitVo() {
        this.firstUnit = "";
        this.jc = "";
        this.pkc = "";
        this.swc = "";
        this.tzc = "";
        this.yyc = "";
        this.zxmbc = "";
        this.total = "";
    }

    public CarJygxUnitVo(CarJygxUnitPo po) {
        DecimalFormat integerFormat = new DecimalFormat("#,###");
        this.firstUnit = po.getFirstUnit();
        this.jc = integerFormat.format(po.getJc());
        this.pkc = integerFormat.format(po.getPkc());
        this.swc = integerFormat.format(po.getSwc());
        this.tzc = integerFormat.format(po.getTzc());
        this.yyc = integerFormat.format(po.getYyc());
        this.zxmbc = integerFormat.format(po.getZxmbc());
        this.total = integerFormat.format(po.getTotal());
    }
}
