package com.nokia.finance.tasks.pojo.vo.car_report;

import com.nokia.finance.tasks.pojo.po.car_report.CarSnfyPo;
import lombok.Data;

import java.text.DecimalFormat;

@Data
public class CarSnfyVo {
    /**
     * 序号
     */
    private String num;
    /**
     * 单位
     */
    private String firstUnit;
    /**
     * 本年
     */
    private String tyFy;
    /**
     * 上年
     */
    private String lyFy;
    /**
     * 预算累计
     */
    private String budgetLj;
    /**
     * 同比增减
     */
    private String tbzj;
    /**
     * 同比百分比
     */
    private String tbbfb;
    /**
     * 预算偏差
     */
    private String yspc;
    /**
     * 偏差百分比
     */
    private String yspcbfb;

    public CarSnfyVo(String num, String firstUnit) {
        this.num = num;
        this.firstUnit = firstUnit;
        this.tyFy = "";
        this.lyFy = "";
        this.budgetLj = "";
        this.tbzj = "";
        this.tbbfb = "";
        this.yspc = "";
        this.yspcbfb = "";
    }

    public CarSnfyVo(Integer num, String firstUnit) {
        this.num = String.valueOf(num);
        this.firstUnit = firstUnit;
        this.tyFy = "0.00";
        this.lyFy = "0.00";
        this.budgetLj = "0.00";
        this.tbzj = "0.00";
        this.tbbfb = "0.00%";
        this.yspc = "0.00";
        this.yspcbfb = "0.00%";
    }

    public void update(CarSnfyPo carSnfyPo) {
        DecimalFormat numberFormat = new DecimalFormat("#,##0.00");
        DecimalFormat percentFormat = new DecimalFormat("0.00%");
        this.tyFy = numberFormat.format(carSnfyPo.getTyFy());
        this.lyFy = numberFormat.format(carSnfyPo.getLyFy());
        this.budgetLj = numberFormat.format(carSnfyPo.getBudgetLj());
        this.tbzj =  numberFormat.format(carSnfyPo.getTbzj());
        this.tbbfb = carSnfyPo.getTbbfb() == null ? "" : percentFormat.format(carSnfyPo.getTbbfb());
        this.yspc = numberFormat.format(carSnfyPo.getYspc());
        this.yspcbfb = carSnfyPo.getYspcbfb() == null ? "" : percentFormat.format(carSnfyPo.getYspcbfb());
    }
}
