package com.nokia.finance.tasks.pojo.vo.car_report;

import com.nokia.finance.tasks.pojo.po.car_report.CarZlwxycPo;
import lombok.Data;

import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.time.format.DateTimeFormatter;

@Data
public class CarZlwxycVo {
    /**
     * 车牌号
     */
    private String chePaiHao;
    /**
     * 一级
     */
    private String firstUnit;
    /**
     * 二级
     */
    private String secondUnit;
    /**
     * 三级
     */
    private String thirdUnit;
    /**
     * 车辆所属单位
     */
    private String cheLiangSuoShuDanWei;
    /**
     * 累计维修
     */
    private String weiXiuSum;
    /**
     * 排名
     */
    private String weiXiuRank;
    /**
     * 车龄
     */
    private String cheLing;
    /**
     * 登记日期
     */
    private String dengJiRiQi;
    /**
     * 车辆来源
     */
    private String cheLiangLaiYuan;
    /**
     * 车辆类型
     */
    private String cheLiangLeiXing;
    /**
     * 车辆使用性质
     */
    private String cheLiangShiYongXingZhi;

    public CarZlwxycVo() {
        this.chePaiHao = "";
        this.firstUnit = "";
        this.secondUnit = "";
        this.thirdUnit = "";
        this.cheLiangSuoShuDanWei = "";
        this.weiXiuSum = "";
        this.weiXiuRank = "";
        this.dengJiRiQi = "";
        this.cheLing = "";
        this.cheLiangLaiYuan = "";
        this.cheLiangLeiXing = "";
        this.cheLiangShiYongXingZhi = "";
    }

    public CarZlwxycVo(CarZlwxycPo carZlwxycPo) {
        DateTimeFormatter dateTimeFormatter = DateTimeFormatter.ofPattern("yyyy/MM/dd");
        DecimalFormat numberFormat = new DecimalFormat("#,##0.00");
        DecimalFormat integerFormat = new DecimalFormat("#,###");
        this.chePaiHao = carZlwxycPo.getChePaiHao();
        this.firstUnit = carZlwxycPo.getFirstUnit();
        this.secondUnit = carZlwxycPo.getSecondUnit();
        this.thirdUnit = carZlwxycPo.getThirdUnit();
        this.cheLiangSuoShuDanWei = carZlwxycPo.getCheLiangSuoShuDanWei();
        this.weiXiuSum = numberFormat.format(carZlwxycPo.getWeiXiuSum());
        this.weiXiuRank = integerFormat.format(carZlwxycPo.getWeiXiuRank());
        this.dengJiRiQi = carZlwxycPo.getDengJiRiQi() == null ? ""
                : dateTimeFormatter.format(carZlwxycPo.getDengJiRiQi());
        this.cheLing = carZlwxycPo.getCheLing() == null ? ""
                : integerFormat.format(carZlwxycPo.getCheLing().setScale(0, RoundingMode.CEILING));
        this.cheLiangLaiYuan = carZlwxycPo.getCheLiangLaiYuan();
        this.cheLiangLeiXing = carZlwxycPo.getCheLiangLeiXing();
        this.cheLiangShiYongXingZhi = carZlwxycPo.getCheLiangShiYongXingZhi();
    }
}
